

---------------------------------------
-- NORMAL MAPPED RADIOSITY MATERIALS --
---------------------------------------

local radNormalMapped = true;
--local radNormalMapped = false;
local radNM = "asteroid.TGA"
--local radNM = "blank.TGA"
local nrmDiffuse = 1.00
local nrmSpecular = 0.5



function nrmColor(r, g, b)
	local mat = {}	
	mat.lighted = displayLighted;
	mat.diffuse = color(nrmDiffuse * r, nrmDiffuse * g, nrmDiffuse * b) 
	if radNormalMapped then 
		mat.normal = tex_normal(radNM)
		set_compression_flag(mat.normal, false)
	end
	mat.specular_on = true
	mat.specularity = 0.98
	mat.gloss = color(nrmSpecular * r, nrmSpecular * g, nrmSpecular * b) 
	-- normal mapped radiosity demo
	if static_ambient_level_slider ~= nil then
		mat.precomputed_ambient_factor = static_ambient_level_slider()
		mat.indirect_lighting_factor = dynamic_ambient_level_slider()
		if radNormalMapped then
			--mat.normal = mul(mat.normal, bumpiness_slider())
			mat.normal = lerp(color(0, 0, 1), mat.normal, bumpiness_slider())
		end
		mat.direct_lighting_factor = direct_lighting_level_slider()
	end
	return mat
end

function nmrWhite()
	return nrmColor(0.9, 0.9, 0.9)
end

function nmrRed()
	return nrmColor(1, 0.05, 0.05)
end

function nmrGreen()
	return nrmColor(0.1, 0.9, 0.1)
end


function nmrYellow()
	return nrmColor(1, 0.25, 0.02)
end

function nmrYellow2()
	return nrmColor(0.9, 0.9, 0.1)
end

function nmrMagenta()
	return nrmColor(1, 0.2, 1)
end

function nmrCyan()
	return nrmColor(0.2, 1, 1)
end

function nmrBlack()
	return nrmColor(0, 0, 0)
end

function indirectLightSphere()
	return nrmColor(1, 1, 1)	
end


function indirectLightVoxelMat()
	local mat = {}
	mat.lighted = false
	mat.diffuse = vertex_color0()
	mat.double_sided = true
	return mat
end


